/*
 ============================================================================
 Name        : semaforo.cpp
 Author      : Anderson Moreira
 E-mail		 : anderson.moreira@recife.ifpe.edu.br
 Version     : 13/06/2011
 Copyright   : 
 Description : Programa para implementa uma classe de semforo escalar de Dijsktra.
 ============================================================================
 */

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

union semun
{
	int val;
};

class Semaforo
{
public:
	int sem_id; // identificador do semforo
    int num_sems; // nmero de semforos- sugere-se valor igual a 1: semforo escalar
    union  semun sem_union; // union utilizada para a funo semtcl()
    struct sembuf sem_b;   // estrutura utilizado para semop()
    int retorno_inicio, valor_final;

    Semaforo(key_t chave, int val_inicial, int sem_flags)
    {
    	// val_inicial - valor sugerido = 1
    	// sem_flags - valor sugerido = 0666 | IPC_CREAT

    	num_sems = 1;
    	sem_b.sem_num = 0; // uma operao
    	sem_b.sem_flg = SEM_UNDO;

    	sem_union.val = val_inicial;

    	// criando um semforo
    	sem_id = semget(chave, num_sems, sem_flags);

    	// iniciando o semforo
    	retorno_inicio = semctl(sem_id, 0, SETVAL, sem_union);
    }

    Semaforo(key_t chave, int sem_flags)
    {
    	// val_inicial - valor sugerido = 1
    	// sem_flags - valor sugerido = 0666 | IPC_CREAT

    	num_sems = 1;
    	sem_b.sem_num = 0; // uma operao
    	sem_b.sem_flg = SEM_UNDO;

    	// criando um semforo
    	sem_id = semget(chave, num_sems, sem_flags);
    }

   void P(void)
   {
	   sem_b.sem_op = -1;
	   semop(sem_id, &sem_b,1);
   }

   void V(void)
   {
	   sem_b.sem_op = 1;
	   semop(sem_id, &sem_b, 1);
   }

  ~Semaforo(void)
   {
	  // union semun sem_union2;
	  valor_final = semctl(sem_id, 0, IPC_RMID, sem_union);
   }
};
